##
##  knox.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_opkg  1.0.0
%define       V_dist  20200306

#   package information
Name:         knox
Summary:      Secret Store
URL:          https://github.com/pinterest/knox
Vendor:       Pinterest
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Database
License:      Apache
Version:      %{V_opkg}.%{V_dist}
Release:      20200306

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/knox/knox-%{V_dist}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Knox is a service for storing and rotation of secrets, keys, and
    passwords used by other services.

%track
    prog knox:release = {
        version   = %{V_opkg}
        url       = https://github.com/pinterest/knox/releases
        regex     = (__VER__)\.tar\.gz
    }
    prog knox:snapshot = {
        version   = %{V_dist}
        url       = http://download.openpkg.org/components/versioned/knox/
        regex     = knox-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n knox

%build
    #   build program
    export GOPATH=`pwd`
    go build -v -o knox-dev-server github.com/pinterest/knox/cmd/dev_server
    go build -v -o knox-dev-client github.com/pinterest/knox/cmd/dev_client
    go build -v -o knox-migrate-db github.com/pinterest/knox/cmd/migrate_db

%install
    #   install program
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin
    %{l_shtool} install -c -s -m 755 \
        knox-dev-server \
        knox-dev-client \
        knox-migrate-db \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

